@import "utils";

* {
	box-sizing: border-box;
}

body,
html,
#root {
	margin: 0;
	padding: 0;
	font-family: Arial, Helvetica, sans-serif;
}

.flight-search {
	$g: &;
	background-color: $primary-background-color;
	width: 80%;
	height: fit-content;
	padding-bottom: 30px;
	color: $primary-color;
	box-shadow: 0 0.1rem 0.4rem 0 #0003;
	display: flex;
	flex-direction: column;

	&-robe {
		width: 80%;

		&.focus {
			width: 100vw;
			height: 100%;
			background-color: #0000004d;
			position: absolute;
			isolation: isolate;
			z-index: 1;
			left: 0;
			top: 0;

			& + .flight-search {
				z-index: 1;
			}
		}
	}

	&-tab-wrapper {
		background-color: white;
		font-size: 1em;
		border-bottom: 1px solid
			darken($color: $primary-background-color, $amount: 20%);
		color: darken($color: $primary-background-color, $amount: 50%);

		.form-tab {
			display: flex;
			gap: 2em;
			margin-left: 2em;
			font-size: 1em;

			&-link {
				position: relative;
				height: 100%;
				padding: 20px 0;
				cursor: pointer;

				&:hover {
					color: $primary-color;
				}

				&.active {
					color: $primary-color;
				}

				:is(&:hover, .active)::after {
					content: "";
					background-color: $primary-color;
					position: absolute;
					bottom: 0;
					left: 0;
					isolation: isolate;
					z-index: 1;
					width: calc(100% + 20px);
					height: 5px;
				}
			}
		}
	}

	&-form-wrapper {
		flex: 1;
	}

	&-form {
		.form-content-wrapper {
			display: flex;
			flex-direction: column;
			gap: 2em;
			margin: 15px;
			margin-top: 30px;

			.row {
				display: flex;
				width: 100%;
				flex: 1;
				justify-content: start;
				gap: 3em;

				&:first-child > :last-child {
					margin-left: auto;
				}
				&:first-child > :first-child {
					margin: 0;
					justify-self: left;
				}
			}

			.btn-secondary {
				width: $third-percent;
				left: 8.33333%;
			}

			&.hidden {
				display: none;
			}

			.access-code {
				width: $third-percent;
				max-width: 50%;
				min-width: 30%;
			}
		}

		.form-error-wrapper {
			background-color: white;
			border: 1px solid #dcdcdc;
			padding: 1em;

			& ul {
				list-style: none;
				padding: 0 0 0 1.5em;
			}
		}

		#search-btn {
			margin-left: auto;
		}

		#expand-btn {
			transition: none;
		}

		.date-inputs {
			display: flex;
			justify-content: space-between;
			gap: 1em;
			width: $third-percent;

			& #{$g}-input-wrapper {
				max-width: 50%;
				min-width: 30%;
				width: 50%;
			}

			.reset-date-btn {
				margin: 0;
			}
		}

		#{$g}-input-wrapper {
			$text-size: 1em;

			display: flex;
			background-color: $primary-background-color;
			border-bottom: 2px solid $primary-color;
			transition: $primary-transition;
			width: 100%;
			height: 2em;
			position: relative;
			padding-left: 5px;

			.invalid {
				& input {
					color: #c00 !important;
				}

				& button {
					background-color: #c00;
				}
			}

			.error-message {
				left: 0;
				bottom: -1.8em;
				font-size: 0.8em;
				padding: 0 0.3em;
				position: absolute;
			}

			& .bottom-label {
				@extend .input-label;
				position: absolute;
				width: 100%;
				bottom: -3.5em;
				left: 0;
			}

			&.optional {
				border-bottom: 2px solid $placeholder-color !important;

				.input-label {
					align-self: center;
				}
			}

			#{$g}-input {
				outline: none;
				border: none;
				height: 2em;
				width: 100%;
				font-size: $text-size;
				color: $primary-color;
				background-color: transparent;

				&::placeholder {
					color: $placeholder-color;
				}

				&:focus::placeholder {
					color: transparent;
				}
			}

			#{$g}-input-label {
				display: none;
				@extend .input-label;
			}

			&:has(#{$g}-input:focus) {
				box-shadow: $primary-box-shadow;
				background-color: white;
			}

			&:has(#{$g}-input:focus) #{$g}-input-label {
				position: absolute;
				display: block;
				top: -(1em + $label-size);
				left: 0;
			}
		}
	}

	&-modal {
		border: none;
		box-shadow: 0 5px 15px #00000080;
		width: 350px;
		height: 400px;
		color: $primary-color;
		display: flex;
		flex-direction: column;
		justify-content: space-between;

		&-wrapper {
			background-color: #0000004d;
			position: fixed;
			z-index: 5;
			left: 0;
			top: 0;
			width: 100%;
			height: 100%;
			display: flex;
			justify-content: center;
			align-items: center;
		}

		&-header {
			font-size: 1.5em;
			display: flex;
			justify-content: space-between;
			margin-bottom: 1em;

			.close-btn {
				font-size: 0.8em;
				transition: none;
				font-weight: normal;
				color: #52627c;
			}
		}

		&-body {
			flex: 1;
			width: 100%;
			display: flex;
			flex-direction: column;
			gap: 2em;

			& .steppers {
				flex: 1;
				display: flex;
				flex-direction: column;
				justify-content: space-around;
				font-size: 1em;
				color: #666;

				& .stepper-row {
					display: flex;
					justify-content: space-between;

					.error-message {
						font-size: 0.6em;
						left: 0;
						bottom: 0;
					}
				}
			}
		}
	}

	&-stepper {
		display: grid;
		grid-template-columns: 1fr 1fr 1fr;
		grid-template-rows: 100%;
		justify-content: space-around;
		align-items: center;
		border: 2px solid black;
		padding: 0;
		height: fit-content;
		width: fit-content;

		& > * {
			padding: 2px;
			margin: 0;
			height: 100%;
		}

		& :has(button:focus) {
			box-shadow: $primary-box-shadow;
		}

		.stepper-btn {
			transition: none;
			border-radius: none;

			&:hover {
				background-color: $primary-color;
				color: #666;
				border-radius: 0;
			}

			&:disabled {
				color: lighten($color: #666, $amount: 30%);

				&:hover {
					background: none;
				}
			}
		}
	}

	&-dropdown {
		$dropdown-parent-class: &;
		color: $primary-color;
		position: relative;

		.btn {
			color: $primary-color;
		}

		& :not(.input-label) {
			font-size: 1em;
		}

		&-options {
			box-shadow: 0 0.125rem 0.25rem #0006;
			display: flex;
			flex-direction: column;
			width: 100%;
			position: absolute;
			top: 3em;
			background-color: white;
			z-index: 1;

			& .option {
				padding: 0.7em 0.3em;
				background-color: white;

				&.selected {
					background-color: #05164d;
					color: white;
				}

				&:not(.selected):hover {
					background-color: #414e63;
					color: white;
				}
			}
		}

		&.stepper-dropdown {
			#{$dropdown-parent-class}-options {
				font-size: 0.8em;
				top: 2.6em;
				left: 0;
				text-align: center;
				max-height: 300px;
				overflow-y: scroll;

				&-option {
					padding: 0 15px 0 0;
					margin: 0;
				}
			}
		}
	}

	&-location-input {
		width: $third-percent;
		min-width: 30%;
		max-width: 50%;

		#{$g}-dropdown-options {
			max-height: 300px;
			overflow-y: scroll;

			& .option {
				display: grid;
				grid-template-columns: 1fr 1fr 1fr;
				justify-content: start;
				font-size: 0.7em;
				padding-left: 1em;
				padding-right: 1em;

				& > :last-child {
					justify-self: end;
				}
			}
		}
	}
}
